"use strict";
/**
 * @author Timur Kuzhagaliyev <tim.kuzh@gmail.com>
 * @copyright 2020
 * @license MIT
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.hexToRGB = exports.useCommonEntryStyles = exports.GridEntryPreviewFile = exports.GridEntryPreviewFolder = void 0;
var react_1 = __importStar(require("react"));
var icon_helper_1 = require("../../util/icon-helper");
var styles_1 = require("../../util/styles");
var FileThumbnail_1 = require("./FileThumbnail");
var GridEntryDndIndicator_1 = require("./GridEntryDndIndicator");
exports.GridEntryPreviewFolder = react_1.default.memo(function (props) {
    var _a;
    var externalClassName = props.className, entryState = props.entryState, dndState = props.dndState;
    var folderClasses = useFolderStyles(entryState);
    var fileClasses = useFileStyles(entryState);
    var commonClasses = exports.useCommonEntryStyles(entryState);
    var className = styles_1.c((_a = {},
        _a[folderClasses.previewFile] = true,
        _a[externalClassName || ''] = !!externalClassName,
        _a));
    return (react_1.default.createElement("div", { className: className },
        react_1.default.createElement("div", { className: folderClasses.folderBackSideMid },
            react_1.default.createElement("div", { className: folderClasses.folderBackSideTop }),
            react_1.default.createElement("div", { className: folderClasses.folderFrontSide },
                react_1.default.createElement(GridEntryDndIndicator_1.GridEntryDndIndicator, { className: fileClasses.dndIndicator, dndState: dndState }),
                react_1.default.createElement("div", { className: styles_1.c([
                        fileClasses.fileIcon,
                        folderClasses.fileIcon,
                    ]) }, entryState.childrenCount),
                react_1.default.createElement("div", { className: commonClasses.selectionIndicator }),
                react_1.default.createElement(FileThumbnail_1.FileThumbnail, { className: fileClasses.thumbnail, thumbnailUrl: entryState.thumbnailUrl })))));
});
var useFolderStyles = styles_1.makeLocalChonkyStyles(function (theme) { return ({
    previewFile: {
        borderRadius: theme.gridFileEntry.borderRadius,
        position: 'relative',
        overflow: 'hidden',
    },
    folderBackSideTop: {
        backgroundColor: function (state) { return state.color; },
        boxShadow: function (state) {
            var color = theme.gridFileEntry.folderBackColorTint;
            if (state.focused)
                color = 'rgba(0, 0, 0, 0.3)';
            else if (state.selected)
                color = 'rgba(0, 153, 255, .4)';
            return "inset " + color + " 0 0 0 999px";
        },
        borderTopLeftRadius: theme.gridFileEntry.borderRadius,
        borderTopRightRadius: 10,
        position: 'absolute',
        right: '60%',
        height: 13,
        top: -10,
        left: 0,
        '&:after': {
            borderRightColor: theme.palette.background.paper,
            borderTopColor: theme.palette.background.paper,
            borderBottomColor: 'transparent',
            borderLeftColor: 'transparent',
            borderWidth: [0, 15, 10, 0],
            borderStyle: 'solid',
            position: 'absolute',
            display: 'block',
            content: '""',
            right: 0,
            top: 0,
        },
    },
    folderBackSideMid: {
        backgroundColor: function (state) { return state.color; },
        boxShadow: function (state) {
            var color = theme.gridFileEntry.folderBackColorTint;
            if (state.focused)
                color = 'rgba(0, 0, 0, 0.3)';
            else if (state.selected)
                color = 'rgba(0, 153, 255, .4)';
            return "inset " + color + " 0 0 0 999px";
        },
        borderTopRightRadius: theme.gridFileEntry.borderRadius,
        position: 'absolute',
        bottom: 0,
        right: 0,
        left: 0,
        top: 10,
    },
    folderFrontSide: {
        boxShadow: function (state) {
            var shadows = [];
            if (state.focused)
                shadows.push('inset rgba(0, 0, 0, 1) 0 0 0 3px');
            if (state.selected)
                shadows.push('inset rgba(0, 153, 255, .65) 0 0 0 3px');
            shadows.push("inset " + theme.gridFileEntry.folderFrontColorTint + " 0 0 0 999px");
            return shadows.join(', ');
        },
        backgroundColor: function (state) { return state.color; },
        borderRadius: theme.gridFileEntry.borderRadius,
        position: 'absolute',
        overflow: 'hidden',
        bottom: 0,
        right: 0,
        left: 0,
        top: 10,
    },
    fileIcon: {
        fontSize: styles_1.important(theme.gridFileEntry.childrenCountSize),
    },
}); });
exports.GridEntryPreviewFile = react_1.default.memo(function (props) {
    var _a;
    var externalClassName = props.className, entryState = props.entryState, dndState = props.dndState;
    var fileClasses = useFileStyles(entryState);
    var commonClasses = exports.useCommonEntryStyles(entryState);
    var ChonkyIcon = react_1.useContext(icon_helper_1.ChonkyIconContext);
    var className = styles_1.c((_a = {},
        _a[fileClasses.previewFile] = true,
        _a[externalClassName || ''] = !!externalClassName,
        _a));
    return (react_1.default.createElement("div", { className: className },
        react_1.default.createElement(GridEntryDndIndicator_1.GridEntryDndIndicator, { className: fileClasses.dndIndicator, dndState: dndState }),
        react_1.default.createElement("div", { className: fileClasses.fileIcon },
            react_1.default.createElement(ChonkyIcon, { icon: entryState.icon, spin: entryState.iconSpin })),
        react_1.default.createElement("div", { className: commonClasses.selectionIndicator }),
        react_1.default.createElement(FileThumbnail_1.FileThumbnail, { className: fileClasses.thumbnail, thumbnailUrl: entryState.thumbnailUrl })));
});
var useFileStyles = styles_1.makeLocalChonkyStyles(function (theme) { return ({
    previewFile: {
        boxShadow: function (state) {
            var shadows = [];
            if (state.selected)
                shadows.push('inset rgba(0,153,255, .65) 0 0 0 3px');
            if (state.focused)
                shadows.push('inset rgba(0, 0, 0, 1) 0 0 0 3px');
            shadows.push("inset " + theme.gridFileEntry.fileColorTint + " 0 0 0 999px");
            return shadows.join(', ');
        },
        backgroundColor: function (state) { return state.color; },
        borderRadius: theme.gridFileEntry.borderRadius,
        position: 'relative',
        overflow: 'hidden',
    },
    dndIndicator: {
        zIndex: 14,
    },
    fileIcon: {
        transform: 'translateX(-50%) translateY(-50%)',
        fontSize: theme.gridFileEntry.iconSize,
        opacity: function (state) {
            return state.thumbnailUrl && !state.focused ? 0 : 1;
        },
        color: function (state) {
            return state.focused
                ? theme.gridFileEntry.iconColorFocused
                : theme.gridFileEntry.iconColor;
        },
        position: 'absolute',
        left: '50%',
        zIndex: 12,
        top: '50%',
    },
    thumbnail: {
        borderRadius: theme.gridFileEntry.borderRadius,
        position: 'absolute',
        zIndex: 6,
        bottom: 5,
        right: 5,
        left: 5,
        top: 5,
    },
}); });
exports.useCommonEntryStyles = styles_1.makeLocalChonkyStyles(function (theme) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v;
    return ({
        selectionIndicator: {
            display: function (state) { return (state.selected ? 'block' : 'none'); },
            background: "repeating-linear-gradient(45deg, \n            " + ((_d = exports.hexToRGB((_c = (_b = (_a = theme === null || theme === void 0 ? void 0 : theme.palette) === null || _a === void 0 ? void 0 : _a.primary) === null || _b === void 0 ? void 0 : _b.main) !== null && _c !== void 0 ? _c : '', '.14')) !== null && _d !== void 0 ? _d : 'rgba(0,153,255,.14)') + ", \n            " + ((_h = exports.hexToRGB((_g = (_f = (_e = theme === null || theme === void 0 ? void 0 : theme.palette) === null || _e === void 0 ? void 0 : _e.primary) === null || _f === void 0 ? void 0 : _f.main) !== null && _g !== void 0 ? _g : '', '.14')) !== null && _h !== void 0 ? _h : 'rgba(0,153,255,.14)') + " 10px, \n            " + ((_m = exports.hexToRGB((_l = (_k = (_j = theme === null || theme === void 0 ? void 0 : theme.palette) === null || _j === void 0 ? void 0 : _j.primary) === null || _k === void 0 ? void 0 : _k.main) !== null && _l !== void 0 ? _l : '', '.25')) !== null && _m !== void 0 ? _m : 'rgba(0,153,255,.25)') + " 0, \n            " + ((_r = exports.hexToRGB((_q = (_p = (_o = theme === null || theme === void 0 ? void 0 : theme.palette) === null || _o === void 0 ? void 0 : _o.primary) === null || _p === void 0 ? void 0 : _p.main) !== null && _q !== void 0 ? _q : '', '.25')) !== null && _r !== void 0 ? _r : 'rgba(0,153,255,.25)') + " 20px)",
            backgroundColor: (_v = exports.hexToRGB((_u = (_t = (_s = theme === null || theme === void 0 ? void 0 : theme.palette) === null || _s === void 0 ? void 0 : _s.primary) === null || _t === void 0 ? void 0 : _t.main) !== null && _u !== void 0 ? _u : '', '.14')) !== null && _v !== void 0 ? _v : 'rgba(0,153,255,.14)',
            position: 'absolute',
            height: '100%',
            width: '100%',
            zIndex: 10,
        },
        focusIndicator: {
            display: function (state) { return (state.focused ? 'block' : 'none'); },
            boxShadow: 'inset rgba(0, 0, 0, 1) 0 0 0 2px',
            position: 'absolute',
            height: '100%',
            width: '100%',
            zIndex: 11,
        },
    });
});
var hexToRGB = function (hex, alpha) {
    if (!hex) {
        return undefined;
    }
    var r = parseInt(hex.slice(1, 3), 16);
    var g = parseInt(hex.slice(3, 5), 16);
    var b = parseInt(hex.slice(5, 7), 16);
    return alpha ? "rgba(" + r + "," + g + "," + b + "," + alpha + ")" : "rgb(" + r + "," + g + "," + b + ")";
};
exports.hexToRGB = hexToRGB;
